st7/

	#include "LCD.inc"

;******************************************************************************
; obszar pamici danych RAM
;******************************************************************************		
		BYTES
		segment	'ram0'
; zmienne dla procedury dzielenia  dwch liczb 8-bitowych
remaind  	DS.B 1
result   	DS.B 1
number_a 	DS.B 1
number_b 	DS.B 1
counter  	DS.B 1
; zmienna dla procedury writedecimal
cnt				DS.B 1

;******************************************************************************
; obszar pamieci programu		
;******************************************************************************
		WORDS	
		segment 'rom'
		
;**************************************************************************************************
; Precedura wywieltenia liczby dziesitnej na wywietlaczu LCD
; Liczba do wyswietlenia znajduj si w rejestrze A
; Zakres 0..255
;**************************************************************************************************
.writedecimal
		CLR		cnt
wd1	
		LD 		number_a, A		;
		LD 		A, #10				;
		LD 		number_b, A 	; dzielimy przez 10
		RCF		
		CALL 	div_bxb				;
		LD		A, remaind		; reszta z dzielenia do A
		ADD		A, #'0'				; dodajemy kod znaku 'zero'
		PUSH	A							; wysyamy na stos
		INC		cnt						; zwikszamy licznik
		LD		A, result			; wynik z dzielenia do A
		ADD		A, #0					; dodajemy liczb zero (zawarto si nie zmienia, flagi s modyfikowane)
		JRNE	wd1						; jeli wynik niezerowy (konwersja niedokoczona) to skok do wd1
wd2 										; w przeciwnym razie konwersja zakoczona
		POP		A							; zdejmujemy znak ze stosu
		CALL	writedata			; i wywietlamy go na wywietlaczu
		DEC		cnt						; zmniejszamy licznik
		JRNE  wd2						; jeli niezerowy to skok do wd2
		RET

;**************************************************************************************************
; Procedura dzielenia dwch liczb 8-bitowych
;**************************************************************************************************
.div_bxb
; Initialize registers and save the context.
		PUSH 	A 						; zapamitanie zawartoci akumulatora na stosie
		CLR 	result 				; wyzerowanie zmiennej przechowujacej wynik z dzielenia
		CLR 	remaind 			; wyzerowanie zmiennej przechowujcej reszt z dzelenia
		; sprawdzenie argumentw procedury, czy niezerowe.
		LD 		A,number_b 		; sprawdzamy czy nie wystpuje dzielenie przez zero ( zabronione ).
		JRUGT div0 					; jeli nie to testujemy pierwszy argument
end_div 
		POP 	A 						; przywracamy zawarto akumulatora ze stosu.
		RET 								; koniec procedury
div0 
		LD 		A,number_a 		; sprawdzamy czy pierwszy argument jest niezerowy
		JREQ 	end_div 			; jeli tak to koczymy procedur
	
		RCF 								; zerujemy flag przeniesienia.
		LD 		A,#$08 				; inicjujemy licznik
		LD 		counter,A
		LD 		A,number_a ; 
		RLC 	A 						; | obracamy pierwszy argument w lewo i zapamitujemy wynik
		LD 		result,A 			; /
div1 
		LD 		A,remaind 		; 
		RLC 	A 						; | rotate left the remainder register in
		LD 		remaind,A 		; / order to include the carry.
		SUB 	A,number_b
		JRC 	div2 					; test if the subtraction is valid.
		LD 		remaind,A
div2 
		LD 		A,result 			; 
		RLC 	A 						; | rotate left the result register.
		LD 		result,A 			; 
		DEC 	counter
		JREQ 	div3
		JRA 	div1
div3 
		CPL 	A 						; 
		LD 		result,A
		JRA 	end_div
		
		END
		
