st7/
;******************************************************************************
; LITEcomp - aplikacje
; Biblioteka procedur obsugi magistrali I2C
;******************************************************************************
		.nolist	
		#INCLUDE "st7flite19.inc"
		.LIST
				
		#define	I2C_DIR	PBDDR
		#define I2C_DAT	PBDR
		#define	SDA	5
		#define SCL	6
				
;******************************************************************************
; obszar pamici danych RAM
;******************************************************************************
		BYTES
		segment	'ram0'
; zmienne dla procedur I2C
i2c_counter	DS.B 1
i2c_data		DS.B 1

;******************************************************************************
; obszar pamieci programu		
;******************************************************************************
		WORDS
		SEGMENT	'rom'
		
;******************************************************************************
; procedura opniajca dla procedur obsugi magistrali I2C
;******************************************************************************
.i2c_delay
		RET
		
;******************************************************************************
; Procedura generujca sygna START
;******************************************************************************
.i2c_start
		BRES		I2C_DIR, #SDA
		BRES		I2C_DIR, #SCL
		BSET		I2C_DIR, #SDA
		CALL		i2c_delay
		BSET		I2C_DIR, #SCL
		RET
		
;******************************************************************************
; Procedura generujca sygna STOP
;******************************************************************************
.i2c_stop
		BRES		I2C_DIR, #SCL
		CALL		i2c_delay
		BRES		I2C_DIR, #SDA
		RET
		
;******************************************************************************
; Procedura zapisujca bajt na magistral I2C 
; warto bitu ACK zwracana jest we wskaniku C
; Wysyany bajt nalezy umieci w rejestrze A
;******************************************************************************
.i2c_write
		PUSH		A
		LD			i2c_data, A 					; zapamitanie A w zmiennej i2c_data
		LD			A, #8 
		LD			i2c_counter, A 				; ilo powtrze ptli
i2cw1
		BSET		I2C_DIR, #SCL					; stan niski na linii SCL
		BSET		I2C_DIR, #SDA					; stan niski na linii SDA
		LD			A, i2c_data						; przywrcenie danej
		RLC			A											; obrt w lewo przez C
		LD			i2c_data, A						; zapamitanie danej
		JRNC		i2cw2									; skok, jeli C wyzerowany
		BRES		I2C_DIR, #SDA					; w przeciwnym razie ustawienie linii SDA
i2cw2
		BRES		I2C_DIR, #SCL 				; ustawienie linii SCL
		DEC			i2c_counter 					; zmniejszenie licznika ptli
		JRNE		i2cw1 								; skok do i2cw1 jeli wiksze od zera
		BSET		I2C_DIR, #SCL 				; wyzerowanie linii SCL
		BRES		I2C_DIR, #SDA					; wysoki stan na linii SDA
		BRES		I2C_DIR, #SCL					; wysoki stan na linii SCL
		BTJT		I2C_DAT, #SDA, i2cw3 	; stan linii SDA do C
i2cw3		
		BSET		I2C_DIR, #SDA					; wyzerowanie linii SDA
		BSET		I2C_DIR, #SCL					; wyzerowanie linii SCL
		POP			A
		RET

;******************************************************************************
; Procedura odczytujca bajt z magistrali I2C
; Bit ACK przed wywoaniem procedury naley umieci we wskaniku C
;******************************************************************************
.i2c_read
		RLC			A											; zapamietanie bitu ACK przekazanego poprzez wksanik C
		LD			i2c_data, A
		LD			A,#8
		LD 			i2c_counter, A 				; ilo powtrze ptli
		BRES		I2C_DIR, #SDA					; stan wysoki na linii SDA
i2cr1
		CALL 		i2c_delay 						; czekamy chwilk
		BRES		I2C_DIR, #SCL   			; stan wysoki na linii SCL
		BTJT		I2C_DAT, #SDA, i2cr2	; stan linii SDA do C
i2cr2
		LD			A, i2c_data 					; przywracamy poprzednio odczytane bity
		RLC 		A 										; zapamitujemy nowoodebrany bit
		LD			i2c_data, A 					; zapamietujemy
		BSET		I2C_DIR, #SCL					; niski stan na linii SCL
		DEC			i2c_counter 					; zmniejszamy licznik petli
		JRNE		i2cr1 								; skok do i2cr1 jeli wiksze od zera
		BSET		I2C_DIR, #SDA  				; zerujemy lini SDA
		JRNC		i2cr3 								; skok do i2cr3 jesli wskanik C wyzerowany
		BRES		I2C_DIR, #SDA   			; ustawiamy lini sdA
i2cr3		
		BRES		I2C_DIR, #SCL					; ustawiamy lini SCL
		BSET		I2C_DIR, #SCL					; zerujemy lini SCL
		BSET		I2C_DIR, #SDA 				; zerujemy lini SDA
		LD			A, i2c_data 					; w A odebrana dana
		RET

;******************************************************************************
; Koniec pliku I2C.asm
;******************************************************************************
		END
		