st7/
;******************************************************************************
; LITEcomp - aplikacje
; Cyfrowy potencjometr audio sterowany pilotem RC5
;******************************************************************************
		.NOLIST	
		#INCLUDE "st7flite19.inc"
		#include "I2C.inc"
		#include "LCD.inc"
		#include "writedecimal.inc"
		#include "RC5.inc"
    .LIST   
		
;******************************************************************************
; obszar pamici danych RAM
;******************************************************************************
		BYTES 					
		SEGMENT 'ram0'	
volume	DS.b 1			; zmienna przechowujca warto tumienia
muteVol	ds.b 1
;******************************************************************************
; obszar pamieci programu		
;******************************************************************************
		WORDS 					
		SEGMENT 'rom' 
tekst1			STRING "dB    ",0
tekst2  		STRING "   www.btc.pl ", 0
muteTekst 	STRING " MUTE ON",0
tekstminus 	STRING "  -",0
;******************************************************************************
; Pocztek programu gwnego
;******************************************************************************
._reset
		RSP
		LD		PBOR, A
		CALL	RC5Init				; inicjalizacja peryferiw odpowiedzialnych za RC5
		CALL	lcdinit				; inicjalizacja wywietlacza
		LD		A, #64
		CALL	lcdsetaddress	; ustawienie wsprzdnych
		WTXT	tekst2				; wywietlenie adresu strony wydawnictwa BTC
		
		LD		A, #16				; 
		LD		volume, A
		CALL	setVolume			; zapis wartoci tumienia do DS1807
		CALL	displayVolume	; wywietlenie wartosci tumienia na LCD
		BSET	EICR, #7
		BSET	PBOR, #0
		RIM									; odblokowanie przerwa
		
;******************************************************************************
; gwna ptla programu
;******************************************************************************		
mainLoop
		CALL	WaitForRC5		; oczekiwanie na odebranie kodu RC5
		LD		A, RC5Command
		CP		A, #16				; czy odebrano rozkaz 16?
		JRNE	dalej1				; jeli nie to skok do dalej1
		CALL	volUp					; w przeciwnym razie zmniejszenie tumienia
dalej1
		LD		A, RC5Command	
		CP		A, #17				; czy odebrano rozkaz 17?
		JRNE	dalej2				; jeli nie to skok do dalej2
		CALL	volDown				; w przeciwnym razie zwikszenie tumienia
dalej2
		LD		A, RC5Command
		CP		A, #13
		JRNE	dalej3
		CALL	mute
dalej3
		JRA 	mainLoop			; skok do ptli gwnej
		
;******************************************************************************
; Procedura zmniejszajca tumienie (zwikszajca gono)
;******************************************************************************
volUp
		LD		A, volume			; 
		CP		A, #0					; czy osignito minimalne tumienie?
		JREQ	upend					; jeli tak to skok do upend
		SUB		A, #1					; w przeciwnym razie zmniejszamy tumienie
		LD		volume, A			
		CALL	setVolume			; i zapisujemy do ukadu DS1807
		CALL	displayVolume	; oraz wywietlamy na wywietlaczu LCD
upend		
		RET
		
;******************************************************************************
; Procedura zwikszajca tumenie (zmniejszajca gono)
;******************************************************************************
volDown
		LD		A, volume			;
		CP		A, #63				; czy osignito maksymalnie tumienie?
		JREQ	downend				;	jeli tak to skok do downend		
		ADD		A, #1					;	w przeciwnym razie zwikszamy tumienie	
		LD		volume, A			;
		CALL	setVolume			;	i zapisujemy do ukadu DS1807
		CALL	displayVolume
downend
		RET

;******************************************************************************
; Procedura zapisu wartoci tumenia do ukadu DS1807
;******************************************************************************
setVolume
		CALL	i2c_start			; start
		LD		A, #$50				; adres ukadu DS1807
		CALL	i2c_write
		LD		A, #$AF				; polecenie WRITE BOTH POTS
		CALL	i2c_write
		LD		A,volume			; zapis wartoci tumenia
		CALL	i2c_write
		CALL	i2c_stop			; stop
		RET

;******************************************************************************
; Procedura wywietlenia wartoci tumenia na wywietlaczu LCD
;******************************************************************************
displayVolume
		LD		A, #4
		CALL	lcdsetaddress ; ustawienie wsprzdnych
		WTXT	tekstminus
		LD		A, volume
		CALL	writedecimal	; wywietlenie wartoci tumienia
		WTXT	tekst1				; wywietlenie tekstu "dB"
		RET

;******************************************************************************
; Procedura wywietlenia informacji o wyciszeniu na wywietlaczu LCD
;******************************************************************************
displayMute
		LD		A, #4
		CALL	lcdsetaddress ; ustawienie wsprzdnych
		WTXT	muteTekst
		RET

;******************************************************************************
; Procedura ustawiajaca makasymalne tumienie (mute)
;******************************************************************************
mute	
		CALL	i2c_start			; start
		LD		A, #$51				; adres ukadu DS1807 + R
		CALL	i2c_write			
		SCF									; NOACK
		CALL	i2c_read			; odczyt stanu potencjometrw
		LD		muteVol, A
		CALL	i2c_stop			; stop
		
		
		CALL	i2c_start			; start
		LD		A, #$50				; adres ukadu DS1807
		CALL	i2c_write
		LD		A, #$AF				; polecenie WRITE BOTH POTS
		CALL	i2c_write
		LD		A, muteVol
		XOR		A, #%01000000		
		CALL	i2c_write
		CALL	i2c_stop			; stop
		
		LD		A, muteVol
		AND		A, #%01000000	; czy mute waczone?
		JRNE	noMute				; jesli nie to skok do noMute
		CALL	displayMute		; w przeciwnym razie
		JRA		mute1
noMute
		CALL	displayVolume
mute1
		RET

;******************************************************************************
; Procedura obsugi przerwania EI3 od przyciskw S1 i S2
;******************************************************************************
._EI3Vect
		BTJT	PADR, #0, EI3dalej1
		CALL	volUp
		IRET
EI3dalej1
		BTJT	PADR, #2, EI3dalej2
		CALL	volDown
EI3dalej2
		IRET

		END
;******************************************************************************
; Koniec pliku main.asm
;******************************************************************************