st7/
;******************************************************************************
; LITEcomp - aplikacje
; Przykad 4
; Lite Timer
;******************************************************************************
		.NOLIST	
		#INCLUDE "st7flite19.inc"
    .LIST  

LED	EQU	7
S1	EQU	0
S2	EQU	2

;******************************************************************************
; obszar pamici danych RAM
;******************************************************************************
		BYTES 					
		SEGMENT 'ram0'	
counter		DS.B	1
waittime	DS.B	1

;******************************************************************************
; obszar pamieci programu		
;******************************************************************************
		WORDS 					
		SEGMENT 'rom' 

;******************************************************************************
; Pocztek programu gwnego
;******************************************************************************
._reset
		LD		A, #%10000000
		LD		PADDR, A
		LD		PADR, A
		LD		PAOR, A
		LD		A, #%00010000
		LD		LTCSR1, A
		CLR		counter
		LD		A, #128
		LD		waittime, A
		RIM
		
mainLoop
		BTJT	PADR, #S1, mL1			; jeli S1 nie jest wcinity to skok do ML1
		LD		A, waittime				; zaadowanie wartoci watitime do A
		SUB		A, #16						; zmniejszenie o 16
		LD		waittime, A				
		BTJF	PADR, #S1, *				; oczekiwanie na zwolnienie przycisku	
mL1
		BTJT	PADR, #S2, mL2
		LD		A, waittime
		ADD		A, #16
		LD		waittime, A
		BTJF	PADR, #S2, *
mL2
		JRA 	mainLoop 


;******************************************************************************
; Procedura obsugi przerwania od Lite Timer RTC1 (co 1ms)
;******************************************************************************
._LTRTC1Vect
		LD		A, LTCSR1					; wyzerowanie flagi przerwania
		INC		counter						; inkrementacja licznika
		LD		A, counter				; zaadowanie wartoci licznika do A
		CP		A, waittime				; porwnanie wartoci licznika i waittime
		JRNE	exit							; jeli wartoci s rzne to skok do exit
		CLR		counter						; wyzerowanie wartoci licznia
		LD		A, PADR						;
		XOR		A, #$80						; zmiana stanu wyprowadzenia PA7
		LD		PADR, A						;
exit
		IRET

		END
;******************************************************************************
; Koniec pliku main.asm
;******************************************************************************
